



<!DOCTYPE html><html lang=zh-CN><head><meta http-equiv="Content-Type" content="text/html; charset=utf-8" /><meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1"><meta name="applicable-device" content="pc,mobile"><meta name="renderer" content="webkit"><meta name="viewport" content="width=device-width,initial-scale=1.0,maximum-scale=5,viewport-fit=cover">
<title>SQL范式小结</title>	
<script src="//n4.ikafan.com/assets/run_prettify.js?ac"></script>
<link rel="stylesheet" href="//n4.ikafan.com/assetsg/style.css">
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/fontello.css?ac"> -->
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/animation.css?ac"> -->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>
<script src="https://n4.ikafan.com/g/show.js"></script>

</head>
<div id="header" class="navbar navbar-default navbar-fixed-top header-01">
	<div class="container">
		<h1 class="logo">
			<a  href="/" title="巴特西"/>
							巴特西
			</a>
		</h1>
				<div role="navigation"  class="site-nav  primary-menu">
			<div class="menu-fix-box">
				 <ul id="menu-navigation" class="menu" >
<li><a href="/">首页</a></li>
<!-- <li><a href="/search/Hadoop/">Hadoop</a></li>
<li><a href="/search/Linux/">Linux</a></li>
<li><a href="/search/jQuery/">jQuery</a></li> -->
<li><a href="/search/Python/">Python</a></li>
<li><a href="/search/Java/">Java</a></li>
<li><a href="/search/PHP/">PHP</a></li>
<li><a href="/search/IOS/">IOS</a></li>
<li><a href="/search/Andorid/">Andorid</a></li>
<li><a href="/search/NodeJS/">NodeJS</a></li>
<li><a href="/search/JavaScript/">JavaScript</a></li>
<li><a href="/search/HTML5/">HTML5</a></li>
				</ul>					 			
			</div>
		</div>
				<!--<div class="right-nav">
				<button class="js-toggle-search"><i class="icon-search"></i></button>
		</div>-->
       
			</div>	
</div>

<div id="page-content">
	<div class="container">
		<div class="row">
			
			<div class="blog-post">
								<!--<div class="posts-top-cjtz clearfix"></div>-->
								<div class="post">
										<div class="post-title">
											<div id="title_top"></div>
<script>insertAdIfNeeded();</script>
						<h1 class="title">SQL范式小结</h1>
						<div class="post_icon">
							<span class="icon-clock-1"> 2024-02-15 18:22:27 </span>
						</div>
										<div class="post-content">
													<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
											
		<p>说明：大多数初学者对于关系数据库中的范式很是头疼，我本人也是，所以今天又看了视频，总结了一下内容，尽量语言通俗易懂，少用专业术语以及概念。</p>
<p>首先要理解几个键值。</p>
<p>超键：在关系模式中，能唯一标识元组的属性集称为 super key。</p>
<p>候选键：关系模式中，能唯一标识元组并且不含多余属性的属性集称为候选键。值得注意的是，超键与候选键的区别，超键可能含有多余属性，而候选键不能。</p>
<p>主键：在一个关系的若干个候选键中随意指定一个作为关键字，此关键字就是主键。</p>
<p>外键：关系R1中的属性或属性组非R1的码，但它是其他关系的码，那么该属性集对于关系模式R1而言是外键。</p>
<p>主属性：候选码的所有属性称为主属性。</p>
<p>如何区分超键，候选键，主键？</p>
<p>相同点：功能方面，用于唯一标识一个元组。</p>
<p>不同点：超键有多余的属性，主键和候选键没有，它们中的属性是必要的。主键是候选键的一个，只是被数据库设计者选中而已。</p>
<p>联想理解：候选人和候选键，主席与主键。（也就是说，候选键中的任何一个键都可以作为主键，只是设计者之选择了其中的一个。）</p>
<p>（例子是检验概念的唯一标准），大家看例子吧。</p>
<p>例1：学生（学号，姓名，性别，专业号，年龄）</p>
<p>（学号，姓名）是超键，而不是候选键，学号是候选键，同时也是主键。</p>
<p>例2：学生（学号，姓名，性别，专业号，年龄）主键：学号，外键：专业名</p>
<p>专业（专业号，专业名）主键：专业号，外键：无</p>
<p>例3：成绩（学号，姓名，课程号，成绩）学生无同名。</p>
<p>（学号）等价于（姓名）</p>
<p>（学号，课程号）候选键</p>
<p>（姓名，课程号）候选键</p>
<p>所以主属性：学号，姓名，课程号</p>
<p>范式</p>
<p>1NF：通俗的说，就是所有的属性都是不可再分的，复合属性是不允许的。（这一点容易理解）</p>
<p>2FN：</p>
<p>先了解部分函数依赖的概念。</p>
<p>部分函数依赖：主码的部分只要有一部分就可以确定属性的值。</p>
<p>在第一范式的前提下，保证函数依赖关系是全部函数依赖，而非部分函数依赖。</p>
<p><img referrerpolicy="no-referrer"src="http://images.cnitblog.com/blog/635602/201410/112157119835439.png" /></p>
<p>第三范式：</p>
<p>在第二范式的前提下，且没有函数传递依赖于码。</p>
<p>定理：如果某个关系模式，它的关键字是单个关键字，没有部分的函数依赖问题，那么它的肯定是2NF。（仔细理解这句话）</p>
<p><img referrerpolicy="no-referrer"src="http://images.cnitblog.com/blog/635602/201410/112158016243706.png" /></p>
<p><img referrerpolicy="no-referrer"src="http://images.cnitblog.com/blog/635602/201410/112158080463568.png" /></p>
<p>我有点笨，还是初学者，所以有什么不对的地方，还请大家多多指点。</p>												<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
																
<h2>最新文章</h2>	
<ol>
						<li><a href="https://www.batexi.com/a/2q7zlj9e.html">Spring框架概述</a>
		</li>
						<li><a href="https://www.batexi.com/a/g8e1loe9.html">HDU 5944 Fxx and string（暴力&sol;枚举）</a>
		</li>
						<li><a href="https://www.batexi.com/a/oqv1j4oq.html">DatePicker 设置字体颜色</a>
		</li>
						<li><a href="https://www.batexi.com/a/m96m7648.html">什么叫哈希表&lpar;Hash Table&rpar;</a>
		</li>
						<li><a href="https://www.batexi.com/a/jqdooz08.html">Sql获取周、月、年的首尾时间。</a>
		</li>
						<li><a href="https://www.batexi.com/a/rql2n068.html">移除wordpress留言中自动链接功能</a>
		</li>
						<li><a href="https://www.batexi.com/a/r934e6r8.html">Oracle实例和Oracle数据库&lpar;Oracle体系结构&rpar;</a>
		</li>
						<li><a href="https://www.batexi.com/a/5qx1lxv9.html">ZeroMQ（java）中对IO的封装（StreamEngine）</a>
		</li>
						<li><a href="https://www.batexi.com/a/96oen439.html">Sql Server批量停止作业</a>
		</li>
						<li><a href="https://www.batexi.com/a/qv15zdxq.html">Python&mdash;&mdash;str&lpar;字符串&rpar;内部功能介绍</a>
		</li>
						<li><a href="https://www.batexi.com/a/8zog72vq.html">华为HCNA教程（笔记）</a>
		</li>
						<li><a href="https://www.batexi.com/a/96p0w448.html">iOS关于应用内分享</a>
		</li>
						<li><a href="https://www.batexi.com/a/8ojv7mlq.html">Java多线程程序休眠、暂停与停止</a>
		</li>
						<li><a href="https://www.batexi.com/a/qwjro3k8.html">shapeless官方指南翻译总结</a>
		</li>
						<li><a href="https://www.batexi.com/a/q2j6lrv8.html">thinkinginjava学习笔记03&lowbar;基本语法</a>
		</li>
						<li><a href="https://www.batexi.com/a/qv1n27yq.html">【干货分享】dos命令大全</a>
		</li>
						<li><a href="https://www.batexi.com/a/qnj7w4x8.html">CentOS 7 镜像文件各个版本区别</a>
		</li>
						<li><a href="https://www.batexi.com/a/9rgolem8.html">使用工具intellij idea 进行java web开发简介</a>
		</li>
						<li><a href="https://www.batexi.com/a/8m2jxr0q.html">让python bottle框架支持jquery ajax的RESTful风格的PUT和DELETE等请求（新方法）</a>
		</li>
						<li><a href="https://www.batexi.com/a/qyyrwkdq.html">C&plus;&plus; 类中特殊的成员变量（常变量、引用、静态）的初始化方法</a>
		</li>
		</ol>
	

<h2>热门文章</h2>	
<ol>
									<li><a href="https://www.batexi.com/a/rqlrvnxq.html">使用CocoaPods配置工程</a>
			</li>
						<li><a href="https://www.batexi.com/a/2q75d4j9.html">Python 包的相对导入讲解</a>
			</li>
						<li><a href="https://www.batexi.com/a/oqvyjnxq.html">Get the Uniqueid of Action Originate in the AMI</a>
			</li>
						<li><a href="https://www.batexi.com/a/e9p42xk9.html">openstackM版本常见问题汇总</a>
			</li>
						<li><a href="https://www.batexi.com/a/o8o6lp58.html">&lbrack;原创&rsqb;Matlab之按位操作</a>
			</li>
						<li><a href="https://www.batexi.com/a/2q753mj9.html">Collection List Set和Map用法与区别</a>
			</li>
						<li><a href="https://www.batexi.com/a/xq4o2008.html">C4&period;5算法</a>
			</li>
						<li><a href="https://www.batexi.com/a/e9jorkwq.html">Linux2</a>
			</li>
						<li><a href="https://www.batexi.com/a/2q75v6e9.html">由struts错误使用引发的漏洞，使用参数作为返回的文件路径或文件名，作为返回result 值</a>
			</li>
						<li><a href="https://www.batexi.com/a/e9jo72eq.html">Web开发中的主要概念</a>
			</li>
			</ol>			
							
					</div>

					
<div class="next-prev-posts clearfix">
</div>
						 
				</div>
				
	<div class="clear"></div>

			</div>	
			

		</div>
</div>
</div>


<div class="clearfix"></div>
<div id="footer" class="two-s-footer">
	<div class="footer-box">
		<div class="container">
			<div class="row" style="padding-left: 15px;padding-right: 15px;">
			<div class="nav-footer">
				<a href="/">Home</a>
				</div>
				<div class="copyright-footer">
					<p>Powered By WordPress</p>
				</div>
							</div>
		</div>
	</div>
</div>
<div style="display:none">

</div>
<script src="//n4.ikafan.com/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
 </script>
</body>
</html>
